package com.eneraptor.hci

class SysLogController {

    def index = { }
	
	def main = {
		
	}
	
	def browse = {
		
		flash['warnings'] = null
		
		def entries = LoggedData.list()
		Map devices = new HashMap()
		Map icons   = new HashMap()
		List unknownDevices = new ArrayList()
		DeviceInfo.list().each {
			devices[it.deviceId] = it.friendlyName
			if(it.iconPath) {
				icons[it.deviceId] = it.iconPath
			}
		}
		entries.each {
			if(!devices[it.deviceId]) {
				if(!unknownDevices.contains(it.deviceId)) {
					unknownDevices << it.deviceId
				}
			}
		}
		unknownDevices.each {
			if(!flash['warnings']) flash['warnings'] = ""
			flash['warnings'] += "<p>There was found at least one log entry for a device with id <b>${it}</b>, which is <b>unknown</b> to HCI. You should <b>add this device</b> by <b>" + g.link(controller: 'config', action: 'addDevice', params: ['deviceId' : it], "clicking here") + "</b>.</p>"
		}
		
		[data: entries, devices: devices, icons: icons]
		
	}
	
	def detail = {
		
		def detailsOf = LoggedData.findById(params.id)
		if(!detailsOf) {
			flash['errors'] = "<p>There is no logged data with id ${params.id}</p>"
			redirect(action: 'browse')
			return false
		}
		return detailsOf.getProperties()
	}
	
	def deleteEntry = {
		
		def entry = LoggedData.findById(params.id)
		if(entry) {
			entry.delete()
			flash['confirms'] = "<p>Log entry with id " + params.id + " deleted successfully.</p>"
			redirect(action: 'browse')
		} else {
			flash['errors'] = "<p>Cannot find log entry with id " + params.id + "</p>"
			redirect(action: 'browse')
		}
		
	}
	
}
